/*
 * cocoUppleDlg.h : uՂv C_CAO wb_[ t@C
 *          written by H.Tsujimura  16 Dec 2004
 *
 * History:
 * $Log: /makeRSS/uploadFile/cocoUpple/cocoUppleDlg.h $
 * 
 * 8     09/07/03 11:32 Tsujimura543
 * fobOp̃Ot@Co͉\ɂ
 * 
 * 7     07/11/30 23:01 Tsujimura543
 * {_CAOɃt@Chbv邱ƂŁAt@C󂯎悤
 * ɂ
 * 
 * 6     07/11/16 1:03 Tsujimura543
 * \[XR[h𐮗 (]ȃRg폜AȂ)
 * 
 * 5     06/03/14 23:40 Tsujimura543
 * RROt[ɂΉ
 * 
 * 4     06/03/14 21:56 Tsujimura543
 * t@C̍폜@\ǉ
 * 
 * 3     05/04/28 13:33 Tsujimura543
 * enum uploadResult  uploadFileToBlog() ǉ
 * 
 * 2     05/01/04 15:12 Tsujimura543
 * t@CAbv[h֘A\bhC
 * 
 * 1     04/12/16 19:22 Tsujimura543
 * ŏ̔
 */

#if !defined(AFX_COCOUPPLEDLG_H__CAE0F7BF_00C0_4C0F_81B0_C6DFB9D55FBC__INCLUDED_)
#define AFX_COCOUPPLEDLG_H__CAE0F7BF_00C0_4C0F_81B0_C6DFB9D55FBC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CCocoUppleDlg _CAO

class CCocoUppleDlg : public CDialog
{
// \z
public:
	CCocoUppleDlg(CWnd* pParent = NULL);	// W̃RXgN^
    virtual ~CCocoUppleDlg();

// _CAO f[^
	//{{AFX_DATA(CCocoUppleDlg)
	enum { IDD = IDD_COCOUPPLE_DIALOG };
	BOOL	m_useProxy;
	CString	m_blogID;
	CString	m_blogName;
	CString	m_htmlSrc;
	CString	m_password;
	CString	m_targetDirectory;
	CString	m_targetFile;
	CString	m_userName;
	CString	m_targetURL;
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CCocoUppleDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
private:
    enum uploadResult {
        upload_success,         // Abv[h
        upload_failure,         // Abv[hs
        upload_fileNotFound     // Abv[h悤ƂĂt@CȂ
    };

    void    setBlogID();
    void    loadSetting();
    void    saveSetting();
    void    updateUploadButton();
    void    updateSelectBlogButton();
    void    updateDeleteButton();
    void    updateRadioButtons();
    void    getImageSize( const char *filename, int& height, int& width );
    uploadResult    uploadFileToBlog();

    char    m_settingFilename[MAX_PATH];
    BLOGINF m_blogInfo[MAX_BLOGS];
    int     m_numOfBlogs;
    bool    m_needToSave;
    bool    m_cocologFree;
    char    m_path[MAX_PATH];   // cocoUpple.exe ݂̑fBNg

protected:
	HICON m_hIcon;

	// bZ[W }bv֐
	//{{AFX_MSG(CCocoUppleDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnCheckUseproxy();
	afx_msg void OnKillfocusEditUsername();
	afx_msg void OnKillfocusEditPassword();
	afx_msg void OnKillfocusEditTargetDirectory();
	afx_msg void OnKillfocusEditTargetFile();
	afx_msg void OnButtonSelectBlog();
	afx_msg void OnButtonSelectFile();
	afx_msg void OnButtonUpload();
	virtual void OnOK();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnUpdateEditTargetFile();
	afx_msg void OnChangeEditUsername();
	afx_msg void OnChangeEditPassword();
	afx_msg void OnKillfocusEditUrlDelete();
	afx_msg void OnUpdateEditUrlDelete();
	afx_msg void OnButtonDelete();
	afx_msg void OnRadioCocolog();
	afx_msg void OnRadioCocologfree();
	afx_msg void OnDropFiles(HDROP hDropInfo);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}

#endif // !defined(AFX_COCOUPPLEDLG_H__CAE0F7BF_00C0_4C0F_81B0_C6DFB9D55FBC__INCLUDED_)
