/*
 * XML-RPC API oRŃt@CAbv[h
 *   (RROp)
 *
 *    written by H.Tsujimura    2004.12.14
 *
 *    Usage:
 *      uploadFile [-p] -u[U -PpX[h
 *                 [-dAbv[hfBNg]
 *                 -fAbv[ht@C [-buOID]
 *                 -t[F]
 *
 *         -p:  proxy g
 *         -tF: Ώۂ blog ̓RROt[
 *         -t:  Ώۂ blog ̓RROx[VbNARROvXARROv
 *
 * History:
 * $Log: /makeRSS/uploadFile/uploadFile.c $
 * 
 * 9     10/12/28 16:24 Tsujimura543
 * Visual Studio 2010 ́uR[h́vʂQlɃ\[XC
 * 
 * 8     10/12/14 2:02 Tsujimura543
 * VC6 ŃrhꍇłAVC2005 ŃrhꍇƓxɂ̓ZLA
 * Ȃ悤ȍHvĂ݂
 * 
 * 7     10/05/13 22:04 Tsujimura543
 * ZLeB (7) for Visual Studio 2005 or later
 * -- C̍ďCAVisual Studio 2008 Ή
 * -- mF{
 * 
 * 6     10/05/12 11:46 Tsujimura543
 * ZLeB (6) for Visual Studio 2005 or later
 * 
 * 5     10/04/20 4:13 Tsujimura543
 * ZLeB (1) for Visual Studio 2005 or later
 * 
 * 4     07/09/04 22:06 Tsujimura543
 * setVerbose() ̑2ǉɔύX
 * 
 * 3     06/03/14 23:55 Tsujimura543
 * RROt[Ƀt@CAbv[hł邱ƂmF
 * 
 * 2     06/03/14 23:40 Tsujimura543
 * RROt[ɂΉ
 * 
 * 1     04/12/16 19:17 Tsujimura543
 */

#include "xmlRPC.h"
#include <sys/stat.h>

#ifndef	lint
static char	*rcs_id =
"$Header: /makeRSS/uploadFile/uploadFile.c 9     10/12/28 16:24 Tsujimura543 $";
#endif

#define MAX_PROMPT_LEN  80
#define MAX_BLOGS       10  /* VXeőݒu\blog (RRO) */


void
setBlogID( char *blogID )
{
    if ( !(blogID[0]) ) {
        BLOGINF blogInfo[MAX_BLOGS];
        char    prompt[MAX_PROMPT_LEN];
        char    buf[BUFSIZ];
        int     numOfBlogs = MAX_BLOGS;
        int     r, i;

        r = getBlogIDs( NULL, NULL, &numOfBlogs, blogInfo ); /* blogger API */
        if ( r == 1 )
            strcpy( (char *)blogID, blogInfo[0].blogID );/* m */
        else if ( r > 1 ) {
            /* ---- e blog ̑I */
            do {
                for ( i = 0; i < r; i++ ) {
                    printf( "(%d)\t%s (blogID: %s)\n",
                            i + 1,
                            utf2sjis( blogInfo[i].blogName ),
                            blogInfo[i].blogID );
                }
                sprintf( prompt,
                         "ǂ blog ɃAbv[h܂? (1 - %d): ", r );
                inputString( (char *)buf, BUFSIZ,
                             prompt, FALSE );
                i = atoi( buf );
                if ( (i >= 1) && (i <= r) ) {
                    strcpy( blogID, blogInfo[i - 1].blogID );
                    break;
                }
            } while ( (i < 1) || (i > r) );
        }
    }
}


#define setValueFromArgv( str ) \
    if ( argv[i][j + 1] ) { \
        strcpy( (str), &argv[i][j + 1] ); \
        j = strlen( argv[i] ) - 1; \
    } \
    else if ( i + 1 < argc ) { \
        i++; \
        strcpy( (str), argv[i] ); \
        j = strlen( argv[i] ) - 1; \
    }

#define setValueFromArgv_S( str, sz ) \
    if ( argv[i][j + 1] ) { \
        strcpy_S( (str), (sz), &argv[i][j + 1] ); \
        j = strlen( argv[i] ) - 1; \
    } \
    else if ( i + 1 < argc ) { \
        i++; \
        strcpy_S( (str), (sz), argv[i] ); \
        j = strlen( argv[i] ) - 1; \
    }

int
main( int argc, char *argv[] )
{
    char        targetURL[MAX_PATH];
    char        userName[MAX_USERIDLEN];
    char        password[MAX_PASSWDLEN];
    char        blogID[MAX_BLOGIDLENGTH];
    char        url[MAX_URLLENGTH];
    char        targetFile[MAX_PATH];
    char        targetDir[MAX_PATH];
    int         size        = 0;
    int         useProxy    = FALSE;
    int         cocologFree = FALSE;
    int         selected    = FALSE;
    struct stat s;

    memset( targetFile, 0x00, MAX_PATH );
    memset( targetDir,  0x00, MAX_PATH );
    memset( userName,   0x00, MAX_USERIDLEN );
    memset( password,   0x00, MAX_PASSWDLEN );
    memset( blogID,     0x00, MAX_BLOGIDLENGTH );
    memset( url,        0x00, MAX_URLLENGTH );

    if ( argc > 1 ) {
        int i, j;
        for ( i = 0; i < argc; i++ ) {
            if ( argv[i][0] == '-' ) {
                for ( j = 1; argv[i][j]; j++ ) {
                    switch ( argv[i][j] ) {
                    case 'p':
                        useProxy = !useProxy;
                        break;

                    case 'u':
                        setValueFromArgv_S( userName, MAX_USERIDLEN );
                        break;

                    case 'P':
                        setValueFromArgv_S( password, MAX_PASSWDLEN );
                        break;

                    case 'f':
                        setValueFromArgv_S( targetFile, MAX_PATH );
                        break;

                    case 'd':
                        setValueFromArgv_S( targetDir, MAX_PATH );
                        break;

                    case 'b':
                        setValueFromArgv_S( blogID, MAX_BLOGIDLENGTH );
                        break;

                    case 't':
                        if ( argv[i][j + 1] == 'F' ) {
                            cocologFree = TRUE;
                            j++;
                        }
                        selected = TRUE;
                        break;
                    }
                }
            }
        }
    }

    if ( !userName[0] ) {
        fputs( "uloginvw肵Ă!!\n", stderr );
        exit( 255 );
    }

    if ( !password[0] ) {
        fputs( "upX[hvw肵Ă!!\n", stderr );
        exit( 255 );
    }

    if ( !targetFile[0] ) {
        fputs( "uAbv[ht@C̖Ovw肵Ă!!\n",
               stderr );
        exit( 255 );
    }

    if ( !selected ) {
        fputs( "u]̃RRO/RROt[v̂ǂȂ̂A"
               "w肵Ă!!\n",
               stderr );
        exit( 255 );
    }

    strcpy( targetURL, cocologFree ? APIURL_COCOLOGFREE : APIURL_COCOLOG );

    setUserInfo( userName, password );
    setUseProxy( useProxy );
    setTargetURL( targetURL );
    setBlogKind( cocologFree ? BLOGKIND_COCOLOGFREE : BLOGKIND_COCOLOG );
#ifdef  _DEBUG
    setVerbose( TRUE, stderr );
#endif

    setBlogID( blogID );

    if ( stat( targetFile, &s ) == 0 ) {
        size = s.st_size;

        uploadFile( blogID,
                    userName,
                    password,
                    targetDir, /* NULL  󕶎̂Ƃ́AgbvfB */
                               /* NgɃAbv[h         */
                    targetFile,
                    size,
                    "application/unknown",  /* dummy */
                    url, MAX_URLLENGTH
                  );

        if ( url[0] )
            fprintf( stderr, "Abv[ht@C url = %s\n", url );
    }

    return ( 1 );
}
